/*
 * =============================================================================
 * Projrct F-11 - Web SCADA for Java
 * Copyright (C) 2002-2010 Freedom, Inc. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

package org.F11.scada.tool.attribute;

import java.io.Serializable;

/**
 * e[uDtoł
 *
 * @author maekawa
 *
 */
public class Attribute implements Serializable {
	private static final long serialVersionUID = 2244832671549651026L;

	public static final String TABLE = "attribute_table";

	/** ID */
	private Integer attribute;
	/**  */
	private String name;
	/** ONA[F */
	private String onAlarmColor;
	/** OFFA[F */
	private String offAlarmColor;
	/** ONT}[F */
	private String onSummaryColor;
	/** OFFT}[F */
	private String offSummaryColor;
	/** ONv^F */
	private String onPrinterColor;
	/** OFFv^F */
	private String offPrinterColor;
	/** x񉹃^Cv */
	private Integer soundType;
	/** mF^Cv */
	private Boolean checkType;
	/** T}[o^[h */
	private Integer summaryMode;
	/** qXg[o^[h */
	private Integer historyMode;
	/** o^[h */
	private Integer careerMode;
	/** ŐV񗓕\[h */
	private Integer newInfoMode;
	/** v^󎚃[h */
	private Boolean printerMode;
	/** `^Oh~^C}[ */
	private Integer chateringTimer;
	/** A[^Cv\[h */
	private Boolean messageMode;

	/**
	 * ID擾܂B
	 *
	 * @return ID
	 */
	public Integer getAttribute() {
		return attribute;
	}

	/**
	 * IDݒ肵܂B
	 *
	 * @param attribute ID
	 */
	public void setAttribute(Integer attribute) {
		this.attribute = attribute;
	}

	/**
	 * 擾܂B
	 *
	 * @return 
	 */
	public String getName() {
		return name;
	}

	/**
	 * ݒ肵܂B
	 *
	 * @param name 
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * x񉹃^Cv擾܂B
	 *
	 * @return x񉹃^Cv
	 */
	public Integer getSoundType() {
		return soundType;
	}

	/**
	 * x񉹃^Cvݒ肵܂B
	 *
	 * @param soundType x񉹃^Cv
	 */
	public void setSoundType(Integer soundType) {
		this.soundType = soundType;
	}

	/**
	 * ONA[F擾܂B
	 *
	 * @return ONA[F
	 */
	public String getOnAlarmColor() {
		return onAlarmColor;
	}

	/**
	 * ONA[Fݒ肵܂B
	 *
	 * @param onAlarmColor ONA[F
	 */
	public void setOnAlarmColor(String onAlarmColor) {
		this.onAlarmColor = onAlarmColor;
	}

	/**
	 * OFFA[F擾܂B
	 *
	 * @return OFFA[F
	 */
	public String getOffAlarmColor() {
		return offAlarmColor;
	}

	/**
	 * OFFA[Fݒ肵܂B
	 *
	 * @param offAlarmColor OFFA[F
	 */
	public void setOffAlarmColor(String offAlarmColor) {
		this.offAlarmColor = offAlarmColor;
	}

	/**
	 * ONT}[F擾܂B
	 *
	 * @return ONT}[F
	 */
	public String getOnSummaryColor() {
		return onSummaryColor;
	}

	/**
	 * ONT}[Fݒ肵܂B
	 *
	 * @param onSummaryColor ONT}[F
	 */
	public void setOnSummaryColor(String onSummaryColor) {
		this.onSummaryColor = onSummaryColor;
	}

	/**
	 * OFFT}[F擾܂B
	 *
	 * @return OFFT}[F
	 */
	public String getOffSummaryColor() {
		return offSummaryColor;
	}

	/**
	 * OFFT}[Fݒ肵܂B
	 *
	 * @param offSummaryColor OFFT}[F
	 */
	public void setOffSummaryColor(String offSummaryColor) {
		this.offSummaryColor = offSummaryColor;
	}

	/**
	 * ONv^F擾܂B
	 *
	 * @return ONv^F
	 */
	public String getOnPrinterColor() {
		return onPrinterColor;
	}

	/**
	 * ONv^Fݒ肵܂B
	 *
	 * @param onPrinterColor ONv^F
	 */
	public void setOnPrinterColor(String onPrinterColor) {
		this.onPrinterColor = onPrinterColor;
	}

	/**
	 * OFFv^F擾܂B
	 *
	 * @return OFFv^F
	 */
	public String getOffPrinterColor() {
		return offPrinterColor;
	}

	/**
	 * OFFv^Fݒ肵܂B
	 *
	 * @param offPrinterColor OFFv^F
	 */
	public void setOffPrinterColor(String offPrinterColor) {
		this.offPrinterColor = offPrinterColor;
	}

	/**
	 * mF^Cv擾܂B
	 *
	 * @return mF^Cv
	 */
	public Boolean getCheckType() {
		return checkType;
	}

	/**
	 * mF^Cvݒ肵܂B
	 *
	 * @param checkType mF^Cv
	 */
	public void setCheckType(Boolean checkType) {
		this.checkType = checkType;
	}

	/**
	 * T}[o^[h擾܂B
	 *
	 * @return T}[o^[h
	 */
	public Integer getSummaryMode() {
		return summaryMode;
	}

	/**
	 * T}[o^[hݒ肵܂B
	 *
	 * @param summaryMode T}[o^[h
	 */
	public void setSummaryMode(Integer summaryMode) {
		this.summaryMode = summaryMode;
	}

	/**
	 * qXg[o^[h擾܂B
	 *
	 * @return qXg[o^[h
	 */
	public Integer getHistoryMode() {
		return historyMode;
	}

	/**
	 * qXg[o^[hݒ肵܂B
	 *
	 * @param historyMode qXg[o^[h
	 */
	public void setHistoryMode(Integer historyMode) {
		this.historyMode = historyMode;
	}

	/**
	 * o^[h擾܂B
	 *
	 * @return o^[h
	 */
	public Integer getCareerMode() {
		return careerMode;
	}

	/**
	 * o^[hݒ肵܂B
	 *
	 * @param careerMode o^[h
	 */
	public void setCareerMode(Integer careerMode) {
		this.careerMode = careerMode;
	}

	/**
	 * ŐV񗓕\[h擾܂B
	 *
	 * @return ŐV񗓕\[h
	 */
	public Integer getNewInfoMode() {
		return newInfoMode;
	}

	/**
	 * ŐV񗓕\[hݒ肵܂B
	 *
	 * @param newInfoMode ŐV񗓕\[h
	 */
	public void setNewInfoMode(Integer newInfoMode) {
		this.newInfoMode = newInfoMode;
	}

	/**
	 * v^󎚃[h擾܂B
	 *
	 * @return v^󎚃[h
	 */
	public Boolean getPrinterMode() {
		return printerMode;
	}

	/**
	 * v^󎚃[hݒ肵܂B
	 *
	 * @param printerMode v^󎚃[h
	 */
	public void setPrinterMode(Boolean printerMode) {
		this.printerMode = printerMode;
	}

	/**
	 * `^Oh~^C}[擾܂B
	 *
	 * @return `^Oh~^C}[
	 */
	public Integer getChateringTimer() {
		return chateringTimer;
	}

	/**
	 * `^Oh~^C}[ݒ肵܂B
	 *
	 * @param chateringTimer `^Oh~^C}[
	 */
	public void setChateringTimer(Integer chateringTimer) {
		this.chateringTimer = chateringTimer;
	}

	/**
	 * A[^Cv\[h擾܂B
	 *
	 * @return A[^Cv\[h
	 */
	public Boolean getMessageMode() {
		return messageMode;
	}

	/**
	 * A[^Cv\[hݒ肵܂B
	 *
	 * @param messageMode A[^Cv\[h
	 */
	public void setMessageMode(Boolean messageMode) {
		this.messageMode = messageMode;
	}

	public String toString() {
		return attribute
			+ " "
			+ name
			+ " "
			+ onAlarmColor
			+ " "
			+ offAlarmColor
			+ " "
			+ onSummaryColor
			+ " "
			+ offSummaryColor
			+ " "
			+ onPrinterColor
			+ " "
			+ offPrinterColor
			+ " "
			+ soundType
			+ " "
			+ checkType
			+ " "
			+ summaryMode
			+ " "
			+ historyMode
			+ " "
			+ careerMode
			+ " "
			+ newInfoMode
			+ " "
			+ printerMode
			+ " "
			+ chateringTimer
			+ " "
			+ messageMode;
	}
}
